annotate vamp-server/test.sh @ 168:718dd5404855

Add case to exercise JSON responses.
author Lucas Thompson <dev@lucas.im>
date Tue, 31 Jan 2017 14:07:18 +0000
parents 2ada256e47e1
children 353f842ed73f
rev   line source
cannam@150 1 #!/bin/bash
cannam@150 2
cannam@150 3 set -eu
cannam@150 4
cannam@158 5 mydir=$(dirname "$0")
cannam@158 6
cannam@158 7 piperdir="$mydir"/../../piper
cannam@158 8 vampsdkdir="$mydir"/../../vamp-plugin-sdk
cannam@158 9 bindir="$mydir"/../bin
cannam@150 10 schemadir="$piperdir"/json/schema
cannam@150 11
cannam@150 12 if [ ! -d "$schemadir" ]; then
cannam@150 13 echo "WARNING: schema directory $schemadir not found, won't be validating JSON schema" 1>&2
cannam@150 14 fi
cannam@150 15
cannam@150 16 tmpdir=$(mktemp -d)
cannam@150 17
cannam@150 18 if [ ! -d "$tmpdir" ]; then
cannam@150 19 echo "Temp directory creation failed" 1>&2
cannam@150 20 exit 1
cannam@150 21 fi
cannam@150 22
cannam@150 23 trap "rm -rf $tmpdir" 0
cannam@150 24
cannam@150 25 reqfile="$tmpdir/req.json"
cannam@150 26 respfile="$tmpdir/resp.json"
cannam@150 27 allrespfile="$tmpdir/resp.all"
cannam@150 28 input="$tmpdir/input"
cannam@150 29 expected="$tmpdir/expected"
cannam@150 30 obtained="$tmpdir/obtained"
cannam@150 31
cannam@150 32 validate() {
cannam@150 33 local file="$1"
cannam@150 34 local schemaname="$2"
cannam@150 35 if [ -d "$schemadir" ]; then
cannam@150 36 echo " * validating against schema $schemaname... " 1>&2
cannam@150 37 jsonschema -i "$file" "$schemadir/$schemaname.json" 1>&2 && \
cannam@150 38 echo " -> validated against schema $schemaname" 1>&2 || \
cannam@150 39 echo " !! failed to validate $schemaname!" 1>&2
cannam@150 40 else
cannam@150 41 echo "(schema directory $schemadir not found, skipping validation)" 1>&2
cannam@150 42 fi
cannam@150 43 }
cannam@150 44
cannam@150 45 validate_request() {
cannam@150 46 local json="$1"
cannam@150 47 echo "$json" > "$reqfile"
cannam@150 48 validate "$reqfile" "rpcrequest"
cannam@150 49 }
cannam@150 50
cannam@150 51 validate_response() {
cannam@150 52 local json="$1"
cannam@150 53 echo "$json" > "$respfile"
cannam@150 54 validate "$respfile" "rpcresponse"
cannam@150 55 }
cannam@150 56
cannam@158 57 # NB this list of commands includes a couple that are expected to fail
cannam@158 58 # (process before configure, configure with nonexistent handle, finish
cannam@158 59 # same handle twice)
cannam@150 60 cat > "$input" <<EOF
cannam@150 61 {"method":"list"}
cannam@150 62 {"method":"list","params": {"from":["vamp-example-plugins","something-nonexistent"]}}
cannam@150 63 {"method":"list","params": {"from":["something-nonexistent"]}}
cannam@150 64 {"method":"load","id":6,"params": {"key":"vamp-example-plugins:percussiononsets","inputSampleRate":44100,"adapterFlags":["AdaptInputDomain","AdaptBufferSize"]}}
cannam@158 65 {"method":"process","params": {"handle": 1, "processInput": { "timestamp": {"s": 0, "n": 0}, "inputBuffers": [ [1,2,3,4,5,6,7,8] ]}}}
cannam@150 66 {"method":"configure","id":"weevil","params":{"handle":1,"configuration":{"blockSize": 8, "channelCount": 1, "parameterValues": {"sensitivity": 40, "threshold": 3}, "stepSize": 8}}}
cannam@158 67 {"method":"configure","id":9,"params":{"handle":-9999,"configuration":{"blockSize": 8, "channelCount": 1, "parameterValues": {"sensitivity": 40, "threshold": 3}, "stepSize": 8}}}
cannam@150 68 {"method":"process","params": {"handle": 1, "processInput": { "timestamp": {"s": 0, "n": 0}, "inputBuffers": [ [1,2,3,4,5,6,7,8] ]}}}
cannam@150 69 {"method":"finish","params": {"handle": 1}}
cannam@158 70 {"method":"finish","id":"blah","params": {"handle": 1}}
cannam@150 71 EOF
cannam@150 72
cannam@150 73 # Expected output, apart from the plugin list which seems a bit
cannam@150 74 # fragile to check here
cannam@150 75 cat > "$expected" <<EOF
cannam@150 76 {"id": 6, "jsonrpc": "2.0", "method": "load", "result": {"defaultConfiguration": {"blockSize": 1024, "channelCount": 1, "parameterValues": {"sensitivity": 40, "threshold": 3}, "stepSize": 1024}, "handle": 1, "staticData": {"basic": {"description": "Detect percussive note onsets by identifying broadband energy rises", "identifier": "percussiononsets", "name": "Simple Percussion Onset Detector"}, "basicOutputInfo": [{"description": "Percussive note onset locations", "identifier": "onsets", "name": "Onsets"}, {"description": "Broadband energy rise detection function", "identifier": "detectionfunction", "name": "Detection Function"}], "category": ["Time", "Onsets"], "copyright": "Code copyright 2006 Queen Mary, University of London, after Dan Barry et al 2005. Freely redistributable (BSD license)", "inputDomain": "TimeDomain", "key": "vamp-example-plugins:percussiononsets", "maker": "Vamp SDK Example Plugins", "maxChannelCount": 1, "minChannelCount": 1, "parameters": [{"basic": {"description": "Energy rise within a frequency bin necessary to count toward broadband total", "identifier": "threshold", "name": "Energy rise threshold"}, "defaultValue": 3, "extents": {"max": 20, "min": 0}, "unit": "dB", "valueNames": []}, {"basic": {"description": "Sensitivity of peak detector applied to broadband detection function", "identifier": "sensitivity", "name": "Sensitivity"}, "defaultValue": 40, "extents": {"max": 100, "min": 0}, "unit": "%", "valueNames": []}], "programs": [], "version": 2}}}
cannam@158 77 {"error": {"code": 0, "message": "error in process request: plugin has not been configured"}, "jsonrpc": "2.0", "method": "process"}
cannam@150 78 {"id": "weevil", "jsonrpc": "2.0", "method": "configure", "result": {"handle": 1, "outputList": [{"basic": {"description": "Percussive note onset locations", "identifier": "onsets", "name": "Onsets"}, "configured": {"binCount": 0, "binNames": [], "hasDuration": false, "sampleRate": 44100, "sampleType": "VariableSampleRate", "unit": ""}}, {"basic": {"description": "Broadband energy rise detection function", "identifier": "detectionfunction", "name": "Detection Function"}, "configured": {"binCount": 1, "binNames": [""], "hasDuration": false, "quantizeStep": 1, "sampleRate": 86.1328125, "sampleType": "FixedSampleRate", "unit": ""}}]}}
cannam@158 79 {"error": {"code": 0, "message": "error in configure request: unknown plugin handle supplied to configure"}, "id": 9, "jsonrpc": "2.0", "method": "configure"}
cannam@150 80 {"jsonrpc": "2.0", "method": "process", "result": {"features": {}, "handle": 1}}
cannam@150 81 {"jsonrpc": "2.0", "method": "finish", "result": {"features": {"detectionfunction": [{"featureValues": [0], "timestamp": {"n": 11609977, "s": 0}}]}, "handle": 1}}
cannam@158 82 {"error": {"code": 0, "message": "error in finish request: unknown plugin handle supplied to finish"}, "id": "blah", "jsonrpc": "2.0", "method": "finish"}
cannam@150 83 EOF
cannam@150 84
cannam@150 85 # We run the whole test twice, once with the server in Capnp mode
cannam@150 86 # (converting to JSON using piper-convert) and once with it directly
cannam@150 87 # in JSON mode
cannam@150 88
cannam@150 89 #debugflag=-d
cannam@150 90 debugflag=
cannam@150 91
dev@168 92 for request_response_conversion in none json_to_json json_to_capnp ; do
cannam@150 93
cannam@150 94 ( export VAMP_PATH="$vampsdkdir"/examples ;
cannam@150 95 while read request ; do
cannam@150 96 validate_request "$request"
cannam@150 97 echo "$request"
cannam@150 98 done |
dev@168 99 if [ "$request_response_conversion" = "none" ]; then
cannam@158 100 "$bindir"/piper-vamp-simple-server $debugflag json
dev@168 101 elif [ "$request_response_conversion" = "json_to_json" ]; then
dev@168 102 "$bindir"/piper-convert request -i json -o json |
dev@168 103 "$bindir"/piper-vamp-simple-server $debugflag json |
dev@168 104 "$bindir"/piper-convert response -i json -o json
cannam@150 105 else
dev@168 106 # The capnp output doesn't preserve the method name in error
dev@168 107 # responses, so replace those now that we've done the json tests
dev@168 108 perl -i -p -e 's/(error.*"method": )"[^"]*"/$1"invalid"/' "$expected"
cannam@158 109 "$bindir"/piper-convert request -i json -o capnp |
cannam@158 110 "$bindir"/piper-vamp-simple-server $debugflag capnp |
cannam@158 111 "$bindir"/piper-convert response -i capnp -o json
cannam@150 112 fi |
cannam@150 113 while read response ; do
cannam@150 114 echo "$response" >> "$allrespfile"
cannam@150 115 validate_response "$response"
cannam@150 116 done
cannam@150 117 ) < "$input"
cannam@150 118
cannam@150 119 # Skip plugin lists
cannam@150 120 tail -n +4 "$allrespfile" > "$obtained"
cannam@150 121
cannam@150 122 echo "Checking response contents against expected contents..."
cannam@150 123 if ! cmp "$obtained" "$expected"; then
cannam@158 124 diff -U 1 "$obtained" "$expected"
cannam@150 125 else
cannam@150 126 echo "OK"
cannam@150 127 fi
cannam@150 128
cannam@150 129 echo "Checking plugin counts from list responses..."
cannam@150 130
cannam@150 131 # Now check the plugin lists, but as the descriptions etc are
cannam@150 132 # probably a bit fragile, let's just count the number of plugins
cannam@150 133
cannam@150 134 # First, with no "from" arg to the list call
cannam@159 135 list_no_from=$(head -n +1 "$allrespfile" | fmt -1 | grep '"key"' | wc -l | sed 's/[^0-9]//g')
cannam@150 136
cannam@150 137 # Now with a "from" arg that includes the library that exists
cannam@150 138 list_with_good_from=$(tail -n +2 "$allrespfile" | head -n +1 | fmt -1 |
cannam@159 139 grep '"key"' | wc -l | sed 's/[^0-9]//g')
cannam@150 140
cannam@150 141 # Now with a "from" arg that doesn't include any real library
cannam@150 142 list_with_bad_from=$(tail -n +3 "$allrespfile" | head -n +1 | fmt -1 |
cannam@159 143 grep '"key"' | wc -l | sed 's/[^0-9]//g')
cannam@150 144
cannam@150 145 if [ "$list_no_from" != "6" ]; then
cannam@150 146 echo "Wrong number of plugins from list response without \"from\" arg"
cannam@150 147 echo "Expected 6, obtained $list_no_from"
cannam@150 148 false
cannam@150 149 fi
cannam@150 150 if [ "$list_with_good_from" != "6" ]; then
cannam@150 151 echo "Wrong number of plugins from list response with good \"from\" arg"
cannam@150 152 echo "Expected 6, obtained $list_with_good_from"
cannam@150 153 false
cannam@150 154 fi
cannam@150 155 if [ "$list_with_bad_from" != "0" ]; then
cannam@150 156 echo "Wrong number of plugins from list response with bad \"from\" arg"
cannam@150 157 echo "Expected 0, obtained $list_with_bad_from"
cannam@150 158 false
cannam@150 159 fi
cannam@150 160 echo OK
cannam@150 161
cannam@150 162 rm "$allrespfile"
cannam@150 163 done
cannam@150 164
cannam@150 165 echo "Tests succeeded" # set -e at top should ensure we don't get here otherwise